﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Cloning
{
    public partial class FormMain : Form
    {
        public FormMain()
        {
            InitializeComponent();
        }

        private void FormMain_Load(object sender, EventArgs e)
        {
            ShallowCopy.Copy shallow = new ShallowCopy.Copy();
            ShallowCopy.Copy shallow2 = (ShallowCopy.Copy)shallow.Clone();
            shallow2.a.x = 18;
            shallow2.b.y = 19;
            shallow2.b.c.z = 20;
            Console.WriteLine("shallow2.a.x = {0}, shallow.a.x = {1}", shallow2.a.x, shallow.a.x);
            Console.WriteLine("shallow2.b.y = {0}, shallow.b.y = {1}", shallow2.b.y, shallow.b.y);
            Console.WriteLine("shallow2.b.c.z = {0}, shallow.b.c.z = {1}", shallow2.b.c.z, shallow.b.c.z);

            DeepCopy.Copy deep = new DeepCopy.Copy();
            DeepCopy.Copy deep2 = (DeepCopy.Copy)deep.Clone();
            deep2.a.x = 21;
            deep2.b.y = 22;
            deep2.b.c.z = 23;
            Console.WriteLine("deep2.a.x = {0}, deep.a.x = {1}", deep2.a.x, deep.a.x);
            Console.WriteLine("deep2.b.y = {0}, deep.b.y = {1}", deep2.b.y, deep.b.y);
            Console.WriteLine("deep2.b.c.z = {0}, deep.b.c.z = {1}", deep2.b.c.z, deep.b.c.z);

            Constructor.Copy constructor = new Constructor.Copy();
            Constructor.Copy constructor2 = new Constructor.Copy(constructor);
            constructor2.a.x = 24;
            constructor2.b.y = 25;
            constructor2.b.c.z = 26;
            Console.WriteLine("constructor2.a.x = {0}, deconstructorep.a.x = {1}", constructor2.a.x, constructor.a.x);
            Console.WriteLine("constructor2.b.y = {0}, constructor.b.y = {1}", constructor2.b.y, constructor.b.y);
            Console.WriteLine("constructor2.b.c.z = {0}, constructor.b.c.z = {1}", constructor2.b.c.z, constructor.b.c.z);

            MemoryStream stream = new MemoryStream();
            SerializationMethods.Copy serial = new SerializationMethods.Copy();
            SerializationMethods.SerializationMethods.Serialize(stream, serial);
            SerializationMethods.Copy serial2 = (SerializationMethods.Copy)SerializationMethods.SerializationMethods.Deserialize(stream);
            serial2.a.x = 24;
            serial2.b.y = 25;
            serial2.b.c.z = 26;
            Console.WriteLine("serial2.a.x = {0}, serial.a.x = {1}", serial2.a.x, serial.a.x);
            Console.WriteLine("serial2.b.y = {0}, serial.b.y = {1}", serial2.b.y, serial.b.y);
            Console.WriteLine("serial2.b.c.z = {0}, serial.b.c.z = {1}", serial2.b.c.z, serial.b.c.z);

            DeepCopy.Copy reflect = new DeepCopy.Copy();
            DeepCopy.Copy reflect2 = (DeepCopy.Copy) Reflection.Clone(reflect);
            reflect2.a.x = 27;
            reflect2.b.y = 28;
            reflect2.b.c.z = 29;
            Console.WriteLine("reflect2.a.x = {0}, reflect.a.x = {1}", reflect2.a.x, reflect.a.x);
            Console.WriteLine("reflect2.b.y = {0}, reflect.b.y = {1}", reflect2.b.y, reflect.b.y);
            Console.WriteLine("reflect2.b.c.z = {0}, reflect.b.c.z = {1}", reflect2.b.c.z, reflect.b.c.z);
        }



    }
}
